{ dlgshow.pas by Tom Swan -- Display a dialog box }

program DlgShow;

{$IFDEF BWCC}
{$R notes.res}
uses WinTypes, WinProcs, WObjectB, IDs;
{$ELSE}
{$R notesx.res}
uses WinTypes, WinProcs, WObjects, IDs;
{$ENDIF}

type
  TDlgApp = object(TApplication)
    procedure InitMainWindow; virtual;
  end;

  PDlgWin = ^TDlgWin;
  TDlgWin = object(TWindow)
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure CMDialogDisplay(var Msg: TMessage);
      virtual cm_First + cm_DialogShow;
  end;

procedure TDlgApp.InitMainWindow;
begin
  MainWindow := New(PDlgWin, Init(nil, 'DlgShow'));
end;

constructor TDlgWin.Init(AParent: PWindowsObject; ATitle: PChar);
begin
  TWindow.Init(AParent, ATitle);
  Attr.Menu := LoadMenu(HInstance, PChar(id_Menu));
end;

procedure TDlgWin.CMDialogDisplay(var Msg: TMessage);
var Dialog: TDialog;
begin
  Dialog.Init(@Self, PChar(id_NotesDlg));
  Dialog.Execute;
  Dialog.Done;
end;

var
  DlgApp: TDlgApp;
begin
  DlgApp.Init('DlgShow');
  DlgApp.Run;
  DlgApp.Done;
end.
